#!/usr/bin/python
# coding=utf-8

'''
Aquest programa ha estat crear per Marta Badia, Marta Blanco, Adrián Mallén i MIreia Pons. 
Mitjançant aquest programa es prediuen les selenoproteïnes de Colobus angolensis mitjançant la comparació amb Homo sapiens.
Abans d'executar el programa cal tenir una carpeta anomenada queries, i una altra anomenada blastall. A més, en el mateix lloc ha d'haver l'arxiu multifasta amb les sequencies que es volen comparar.

'''

import os
import operator
from sys import exit
import shutil


e=[0,0]

while e==[0,0]:
  
	try: #perque torni un error quan el valor no es el adequat
		exonerate = raw_input( "Vols realitzar un Exonerate?(S/N):").lower()
		genewise = raw_input ("Vols realitzar un GeneWise?(S/N):").lower()
		if exonerate=='s' and genewise=='s':
			e=[1,1]
		elif exonerate=='n' and genewise=='s':
			e=[0,1]
		elif exonerate=='s' and genewise=='n':
			e=[1,0]
		elif exonerate=='n' and genewise=='n':
			e=[2,0]
		else:
			raise Exception

	except Exception:
		print '> El valor no es valid.'

if e==[2,0]:
	print ">exit"
	exit()
else:

	count=0
	fitxer=open('multifastaok.fa', 'r')
	
	

	seqid2seq = {}
	
	for line in fitxer:
		if line.startswith(">"):
			seqid = line[1:].strip()
			seqid2seq.setdefault(seqid, "")
		else:
			seqid2seq[seqid] += line.strip()

	for seqid in seqid2seq.keys():
		out = open("queries/"+seqid+".fa", "w")
		out.write(">"+seqid+"\n")
		out.write(seqid2seq[seqid]+"\n")
		out.close()

	for seqid in seqid2seq.keys():
		if not os.path.exists("./fastafetch/"+seqid):
			os.makedirs("./fastafetch/"+seqid)
		if not os.path.exists("./fastasubseq/"+seqid):
			os.makedirs("./fastasubseq/"+seqid)
		if not os.path.exists("./exonerate/"+seqid):
			os.makedirs("./exonerate/"+seqid)
		if not os.path.exists("./GFF/"+seqid):
			os.makedirs("./GFF/"+seqid)
		if not os.path.exists("./fastatranslate/"+seqid):
			os.makedirs("./fastatranslate/"+seqid)
		if not os.path.exists("./t_coffee/"+seqid):
			os.makedirs("./t_coffee/"+seqid)
		if not os.path.exists("./genewise/"+seqid):
			os.makedirs("./genewise/"+seqid)

	for seqid in seqid2seq.keys():
		blastall = "blastall -a 4 -p tblastn -e 1e-3 -m9 -i ./queries/" +seqid+ ".fa -d /cursos/BI/genomes/2015/Colobus_angolensis_palliatus/genome.fa -o ./blastall/coord" + seqid + ".blast"
		if os.path.isfile("./blastall/coord" + seqid + ".blast"):
			print ("El blastall per la proteina "+seqid+ "  ja existeix")
		else:	
			os.system(blastall)
			print blastall and ("El blastall de la proteina " +seqid+ " s'ha realitzat correctament") 


	for file in os.listdir("./blastall"):
		for seqid in seqid2seq.keys():

			maxminvalues = dict() #Identificador i posició
			table = [] #Taula de dades (és com una matriu) 
			arxiu = open("./blastall/coord" + seqid + ".blast", "r")
			i = 0 #index
			for line in arxiu.readlines():
				if not line.startswith ("#"):
					table.append(line.split("\t"))
					if table[i][1] not in maxminvalues:
						llistaindex=[i]  #AFEGIR INDEXS A LA LLISTA: 
						maxminvalues[table[i][1]]=llistaindex
					else:
						llistaindex=maxminvalues[table[i][1]]
						llistaindex.append(i)
						maxminvalues[table[i][1]]=llistaindex
					i+=1
				
			for x,y in maxminvalues.iteritems():
				
				fastafetch = "fastafetch /cursos/BI/genomes/2015/Colobus_angolensis_palliatus/genome.fa /cursos/BI/genomes/2015/Colobus_angolensis_palliatus/genome.index " +x+ "> ./fastafetch/"+seqid+"/contig" + x + ".fa"
				if os.path.isfile("./fastafetch/"+seqid+"contig" + x + ".fa"):
					print ("El fastafetch per la proteina "+seqid+ "  ja existeix")
				else:	
					os.system(fastafetch)
					print fastafetch 

			
			
				values=[]
				for z in y:
					values.append(table[z][8])
					values.append(table[z][9])

				s = min(values) 
				f = max(values)

				start = int(s) - 50000
				l = int(f) - int(start)
				length = int(l) + 50000
				start = str(start)
				length = str(length)

	
				fastasubseq = "fastasubseq ./fastafetch/"+seqid+"/contig" + str(x) + ".fa " +start+ " "+length+ " > ./fastasubseq/"+seqid+"/subseqcontig" + str(x) + ".fa"
				if os.path.isfile("./fastasubseq/"+seqid+"/subseqcontig" + str(x) + ".fa"):
					print ("El fastasubseq per la proteina "+seqid+ "  ja existeix")
				else:	
					os.system(fastasubseq)
					print fastasubseq 

	if e==[1,1] or e==[1,0]:

		if not os.path.exists("./canvi_ux/"):
			os.makedirs("./canvi_ux/")

		
		for seqid in seqid2seq.keys(): 
			
			f1 = open("./queries/"+seqid+".fa", "r")
			f2 = open("./canvi_ux/"+seqid+".fa", "w")
			for line in f1:
				f2.write(line.replace("U","X"))
			f1.close()
			f2.close()
	
			maxminvalues = dict() #Identificador i posició
			table = [] #Taula de dades (és com una matriu) 
			arxiu = open("./blastall/coord" + seqid + ".blast", "r")
			i = 0 #index
			for line in arxiu.readlines():
				if not line.startswith ("#"):
					table.append(line.split("\t"))
					if table[i][1] not in maxminvalues:
						llistaindex=[i]  #AFEGIR INDEXS A LA LLISTA: 
						maxminvalues[table[i][1]]=llistaindex
					else:
						llistaindex=maxminvalues[table[i][1]]
						llistaindex.append(i)
						maxminvalues[table[i][1]]=llistaindex
					i+=1
					
			for x,y in maxminvalues.iteritems():
			
				exonerate = "exonerate -m p2g --showtargetgff -q ./canvi_ux/" +seqid+ ".fa -t ./fastasubseq/"+seqid+"/subseqcontig" + str(x) + ".fa --exhaustive | egrep -w exon > ./exonerate/"+seqid+"/conpred" + str(x) + ".gff"
				if os.path.isfile("./exonerate/"+seqid+"/conpred" + str(x) + ".gff"):
					print ("El exonerate per la proteina "+seqid+ "  ja existeix")
				else:			
					os.system(exonerate)
					print exonerate

				fastaseqfromGFF = "fastaseqfromGFF.pl ./fastafetch/"+seqid+"/contig" + x + ".fa ./exonerate/"+seqid+"/conpred" + str(x) + ".gff > ./GFF/"+seqid+"/conpred" + str(x) + ".nuc.fa"
				if os.path.isfile("./GFF/"+seqid+"/conpred" + str(x) + ".nuc.fa"):
					print ("El GFF per la proteina "+seqid+ "  ja existeix")
				else:
					os.system(fastaseqfromGFF)
					print fastaseqfromGFF

				fastatranslate = "fastatranslate -F 1 ./GFF/"+seqid+"/conpred" + str(x) + ".nuc.fa > ./fastatranslate/"+seqid+"/conpred" + str(x) + ".aa.fa"
				if os.path.isfile("./fastatranslate/"+seqid+"/conpred" + str(x) + ".aa.fa"):
					print ("El fastatranslate per la proteina "+seqid+ "  ja existeix")
				else:
					os.system(fastatranslate)
					print fastatranslate

				t_coffee = "t_coffee ./canvi_ux/" +seqid+ ".fa ./fastatranslate/"+seqid+"/conpred" + str(x) + ".aa.fa > ./t_coffee/"+seqid+"/t_coffeepred" + str(x) + ".txt"
				if os.path.isfile("./t_coffee/"+seqid+"/t_coffeepred" + str(x)+ ".txt"):
					print ("El t_coffee per la proteina "+seqid+ "  ja existeix")
				else:
					os.system(t_coffee)
					print t_coffee



	if e==[1,1] or e==[0,1]:

		for seqid in seqid2seq.keys(): 
			
			maxminvalues = dict() #Identificador i posició
			table = [] #Taula de dades (és com una matriu) 
			arxiu = open("./blastall/coord" + seqid + ".blast", "r")
			i = 0 #index
			for line in arxiu.readlines():
				if not line.startswith ("#"):
					table.append(line.split("\t"))
					if table[i][1] not in maxminvalues:
						llistaindex=[i]  #AFEGIR INDEXS A LA LLISTA: 
						maxminvalues[table[i][1]]=llistaindex
					else:
						llistaindex=maxminvalues[table[i][1]]
						llistaindex.append(i)
						maxminvalues[table[i][1]]=llistaindex
					i+=1
					
			for x,y in maxminvalues.iteritems():
			
				genewise = "genewise -pep -pretty -cdna -gff ./queries/" +seqid+ ".fa ./fastasubseq/"+seqid+"/subseqcontig" + str(x) + ".fa > ./genewise/"+seqid+"/genewisepred" + str(x) + ".txt"
				if os.path.isfile("./genewise/"+seqid+"/genewisepred" + str(x) + ".txt"):
					print ("El genewise per la proteina "+seqid+ "  ja existeix")
				else:			
					os.system(genewise)
					print genewise

				genewise_reverse = "genewise -pep -pretty -cdna -gff -trev ./queries/" +seqid+ ".fa ./fastasubseq/"+seqid+"/subseqcontig" + str(x) + ".fa > ./genewise/"+seqid+"/genewisepredrev" + str(x) + ".txt"
				if os.path.isfile("./genewise/"+seqid+"/genewisepredrev" + str(x) + ".txt"):
					print ("El genewise reverse per la proteina "+seqid+ "  ja existeix")
				else:			
					os.system(genewise_reverse)
					print genewise_reverse
				





	

